#!/usr/local/bin/perl

print "\nViper v1.3 \(Hale 12/16/1999\)\nWiltered Fire - www.wilter.com/wf\n\n";

$arg_length = @ARGV;
$file = "";
$user = "";
$char = 1;
$pws = 1;
$pwl = 12;      
$ui = 10;
$pf = "";

# need help?

if($ARGV[0] eq "-h" || $ARGV[0] eq "-?" || $ARGV[0] eq "") { &help; }

# process command line arguments

for($i=0;$i<$arg_length;$i++) {
 if($ARGV[$i] eq "-f") { $file = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-u") { $user = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-c") { $char = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-pwl") { $pwl = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-ui") { $ui = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-pws") { $pws = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-lsf") { $lsf = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-pf") { $pf = $ARGV[$i+1]; $i++; }
 if($ARGV[$i] eq "-rf") { $runfor = $ARGV[$i+1]; $i++; }
 }


# handle minimum value (v1.3)
$pws--;

# break early if calling from file

if($lsf) {
 open(LSF,$lsf) || die "Could not open saved file $lsf\!\n";
 $vp_stat = <LSF>; chop($vp_stat);
 
 ## check to see if run has been completed # 
 if($vp_stat eq "--viper_final--") { die "The saved run has been completed - check $lsf for details\n\n"; }

 #continue otherwise

 $pws   = <LSF>; chop($pws);
 $pwl   = <LSF>; chop($pwl);
 $epass = <LSF>; chop($epass);
 $user  = <LSF>; chop($user);
 $nump  = <LSF>; chop($nump);
 $vars  = <LSF>; chop($vars);
 $pf    = <LSF>; chop($pf);
 $ui    = <LSF>; chop($ui);
 @vars = split(/ /,$vars);
 $charset = join("",@vars);
 close(LSF);
 
 print " \[Loaded parameters from file $lsf\]\n";

 &crack($user,$epass,$charset,$runfor,$pwl,$pws,$ui,1,$nump,$pf);
 }

# check for required arguments

if($file eq "" || $user eq "") {
 print "Both the password file and user name are required\n";
 die "\n";
 }

# attempt to load account from file

open(IN,$file) || die "Could not open password file $file\n";
$epass = "";
while(<IN>) {
 chop($_);
 @sort = split(/:/,$_);
 if(@sort[0] eq $user) { $epass = @sort[1]; }
 }
close(IN);
if($epass eq "") { die "User $user could not be found in $file\n"; }
$pl = length($epass);
if($pl < 4) { die "Bad password for user $user\n"; } # eliminate shadowed 
print "Found user $user \(pw:$epass\)\n";

# load character set

open(IN,"charset.ini") || die "Could not open charset.ini\n";
$charset = "";
while(<IN>) {
 chop($_);
 @sort = split(/:/,$_);
 if(@sort[0] eq $char) { $charset = @sort[1]; }
 }
close(IN);
if($charset eq "") { die "Could not load character set index $char\n"; }

&crack($user,$epass,$charset,$runfor,$pwl,$pws,$ui,0,"",$pf);

######## start subs ###############

## begin help sub ##

sub help {
 print "   -f <file>    File to load password from (required unless using lsf)\n";
 print "   -u <user>    Username to load from file (required unless using lsf)\n\n";
 print "   -lsf <file>  Load saved file from previous session\n";
 print "   -pf <file>   Save progress to file at update interval\n";
 print "   -rf #        Amount of time in minutes to run for (default infinity)\n\n";
 print "   -c #         Character set from charset.ini to use (default 1)\n";         
 print "   -pws #       Minimum password length (starting value - default 1)\n";
 print "   -pwl #       Maximum password length (default 12)\n";
 print "   -ui #        Console update interval (in minutes - default 10)\n";
 die "\n";
 }

## begin crack sub ##

sub crack {
 my($user,$epass,$charset,$runfor,$pwl,$pws,$ui,$lsf,$nump,$pf) = @_;

 @vars = split(//,$charset);
 $varlen = @vars;
 $count = 0;
 $refresh = 0;
 $realpass = "";
 $on = 0;
 $ui = $ui*60;
 $runfor = $runfor*60;

 # confirm runfor
 if($runfor) {
 $trunfor = &convert($runfor);
 @tsort = split(/:/,$trunfor); # only want hh:mm
 print " \[Running for @tsort[0]\:@tsort[1]\]\n"; }

 # get current time and get initial time since 1/1/1970
 $sloctime = localtime();
 $stime = time();
 $ltime = $stime;
 $cur_time = $stime;

 # display info and start 
 print "\nCharacter set $char loaded with $varlen character length\n";
 print "Starting crack on $sloctime\n\n";

 # go on with the show....
 
 if($lsf eq 1) { @pass = split(/\,/,$nump); $on = 1;}

 $salt = substr($epass,0,2); 

 for($i=$pws;$i<$pwl;$i++) {
  ### make new password ###
  $it = $i+1;
  
  if($on eq 1) { $on = 0; } else { for($j=0;$j<$it;$j++) { @pass[$j] = 0; } }
  
  print "Cracking for pass length \[$it\]\n";

  ### start loop for this length ###
  while(@pass[0] ne $varlen) {
   $count++;
   $refresh++;   

   ### make actual password out of array ###
   $pass = "";
   for($y=0;$y<@pass;$y++) { $pass = $pass . @vars[@pass[$y]]; }

   ## - done - ##
   
   ### Here is where the magic happens ###
   $cpass = crypt($pass,$salt); # the point of the whole script
   if($epass eq $cpass) { 
    $realpass = $pass;
    the_res($user,$realpass,$stime,$sloctime,$pf); 
    }         

   ## - time check - ##
   if($count eq 500000) { 
    $rtime = time(); 
    $time_dif = $rtime - $cur_time; 
    $uicount = $uicount + $count;
    $count=0;
    }
   
   ## - ui check - ##
   if($time_dif >= $ui) {
    # calculate duration and cps
    $ctime = time();
    $cur_time = $ctime;
    $totdur = $ctime - $stime;
    $temp_dur = $ctime - $ltime;
    $ltime = $ctime;
    $cps = int $uicount / $temp_dur;

    #change second format into hh:mm:ss

    $dur = &convert($totdur);

    #display data

    print "[ Length : $it \| Last: $pass \| CPS: $cps \| Time : $dur ]\n";
    
    ## additional conditional routine : auto-save progress (v1.3)

    if($pf ne "") {
     $numpass = join("\,",@pass);
     $uia = $ui / 60;
     open(TMP,">$pf") || print STDOUT "Could not open progress file $pf!\n";
     print TMP "--viper_prog--\n$i\n$pwl\n$epass\n$user\n$numpass\n@vars\n$pf\n$uia\n";
     close(TMP);
     }
    
    ## check for -rf expiration
    if($runfor) {
    if($totdur >= $runfor) { die "\n \[ RunFor duration expired \]\n"; } }
    
    ## update time counter
    $uicount = 0;
    $time_dif = 0;
    }
   ## whee... ##   

   ### create next password array ###
   $l = @pass;
   $l--;
   @pass[$l]++;   # wow.. this is an important line... 
   for($r=$l;$r>0;$r--) { if(@pass[$r] eq $varlen) { @pass[$r-1]++; @pass[$r] = 0; } }
   ## done with that ###
   }
  }
 the_res($user,$realpass,$stime,$sloctime,$pf);
 }

## begin results sub ##

sub the_res {
my($user,$realpass,$stime,$sloctime,$pf) = @_;
 
if($realpass ne "") { 
  $loctime = localtime();
  $etime = time();
  $ttime = $etime - $stime;
  $duration = &convert($ttime);
  $message = "
  The password has been located!
  Username : $user 
  Password : $realpass
  Started  : $sloctime
  Finished : $loctime
  Time     : $duration
  ";
  } else {
  $message = "
  The password could not be located
  Username : $user 
  Password : ???
  Started  : $sloctime
  Finished : $loctime
  Time     : $duration
  ";
   }
  print "$message\n";

if($pf ne "") {
 open(FINAL,">$pf") ;
 print FINAL "--viper_final--\n\n$message";
 close(FINAL);
 }

die "Viper exiting...\n";
}

## begin time convert sub ##

sub convert {
 my($totdur) = @_;
 for($vt=0;$vt<3;$vt++) { @vta[$vt] = 0; }
 @vta[0] = $totdur;
 for($vt=@vta[0];@vta[0]>59;$vt++) { @vta[1]++; @vta[0] -= 60; }
 for($vt=@vta[1];@vta[1]>59;$vt++) { @vta[2]++; @vta[1] -= 60; }
 for($vt=0;$vt<3;$vt++) {  # pad zeros
  $len = length(@vta[$vt]);
  if($len eq 1) { @vta[$vt] = "0" . @vta[$vt]; } 
  }
 $dur = @vta[2] . ":" . @vta[1] . ":" . @vta[0];
 return $dur;
 }
